/*
	Author       : Shortie
	Date         : 06.12.2009
	Description  : read input from 74HC165
	
	siehe auch:	
	http://www.mikrocontroller.net/topic/114713
	http://www.mikrocontroller.net/topic/150759
*/

#include <avr/io.h>
#include <stdlib.h>
#include "../config.h"
#include "sr74hc165.h"

#if USE_SR165

// initialize the array
unsigned char sr165val[SR165_SIZE];

void sr165_read( void )	// http://www.mikrocontroller.net/topic/150759
{
	unsigned char a = 0;
	unsigned char anz = SR165_SIZE;

	SR165_PORT |= (1<<SR165_CLOCK);	// Clock auf 1 halten

	// ein 0/1 Puls auf der PL Leitung. Der 165 bernimmt die
	// externen Datenleitungen ins SR
	SR165_PORT &= ~(1<<SR165_SHIFT);
	SR165_PORT |= (1<<SR165_SHIFT);
  
	// Datenleitung auf Eingang, Pullup aus
	SR165_DDR &= ~(1<<SR165_INPUT);
	SR165_PORT &= ~(1<<SR165_INPUT);

	for(a=0;a<anz;a++)
	{
		// und die 8 Bit abholen    
		for( unsigned char j = 0; j < 8; ++j )
		{
			sr165val[a] <<=1;
			if(SR165_PIN&(1<<SR165_INPUT))	sr165val[a] |= 0x01;
			
			// nchstes Bit aus dem SR mit einem 0/1 Puls raustakten
			SR165_PORT &= ~(1<<SR165_CLOCK);
			SR165_PORT |= (1<<SR165_CLOCK);
		}
	}
}

#endif