/*
	Author       : Shortie
	Date         : 06.12.2009
	Description  : read input from 74HC165
*/

#ifndef _sr165_H_
#define _sr165_H_

#include "../config.h"

// PORTS
#if SR165_PORTA
	#define SR165_PORT		PORTA
	#define	SR165_PIN		PINA
	#define	SR165_DDR		DDRA
	#define SR165_INPUT 	0	//PIN fr Input vom Input-Schieberegister
	#define SR165_SHIFT 	1	//PIN fr Load-Shift Whler
	#define SR165_CLOCK 	2	//PIN fr Clock am Input Register
#endif

#if SR165_PORTC
#if SR165_PORTC_HI
	#define SR165_PORT		PORTC
	#define	SR165_PIN		PINC
	#define	SR165_DDR		DDRC
	#define SR165_INPUT 	4	//PIN fr Input vom Input-Schieberegister
	#define SR165_SHIFT 	5	//PIN fr Load-Shift Whler
	#define SR165_CLOCK 	6	//PIN fr Clock am Input Register
#else
	#define SR165_PORT		PORTC
	#define	SR165_PIN		PINC
	#define	SR165_DDR		DDRC
	#define SR165_INPUT 	0	//PIN fr Input vom Input-Schieberegister
	#define SR165_SHIFT 	1	//PIN fr Load-Shift Whler
	#define SR165_CLOCK 	2	//PIN fr Clock am Input Register
#endif	//SR165_PORTC_HI
#endif	//SR165_PORTC

#if SR165_PORTD
	#define SR165_PORT		PORTD	// EXT-Buchse (Pin 1-3) am AVR-NET-IO
	#define	SR165_PIN		PIND
	#define	SR165_DDR		DDRD
	#define SR165_INPUT 	2	//PIN fr Input vom Input-Schieberegister
	#define SR165_SHIFT 	3	//PIN fr Load-Shift Whler
	#define SR165_CLOCK 	4	//PIN fr Clock am Input Register
#endif


//********** only for internal use. Don't change any value ***************

// global array 
extern unsigned char sr165val[];

// read from 74HC165
extern void sr165_read(void);

#endif /* _sr165_H_ */
