#ifndef _sr74hc595_H_
#define _sr74hc595_H_

#include "../config.h"

// PORTS
#if SR595_PORTA
	#define PORT_sr74hc595 PORTA
	#define PORT_SER 		PA0		//74HC595 PIN 14
	#define PORT_SCK 		PA1		//74HC595 PIN 12
	#define PORT_RCK 		PA2		//74HC595 PIN 11
	#define PORT_OE 		PA3		//74HC595 PIN 13

	#define DDR_sr74hc595  DDRA
	#define DDR_SER 		DDA0	//74HC595 PIN 14
	#define DDR_SCK 		DDA1	//74HC595 PIN 12
	#define DDR_RCK 		DDA2	//74HC595 PIN 11	
	#define DDR_OE 			DDA3	//74HC595 PIN 13
#endif	//SR595_PORTA

#if SR595_PORTC
#if SR595_PORTC_HI
	#define PORT_sr74hc595 PORTC
	#define PORT_SER 		PC4		//74HC595 PIN 14
	#define PORT_SCK 		PC5		//74HC595 PIN 12
	#define PORT_RCK 		PC6		//74HC595 PIN 11
	#define PORT_OE 		PC7		//74HC595 PIN 13

	#define DDR_sr74hc595  DDRC
	#define DDR_SER 		DDC4	//74HC595 PIN 14
	#define DDR_SCK 		DDC5	//74HC595 PIN 12
	#define DDR_RCK 		DDC6	//74HC595 PIN 11	
	#define DDR_OE 			DDC7	//74HC595 PIN 13
#else
	#define PORT_sr74hc595 PORTC
	#define PORT_SER 		PC0		//74HC595 PIN 14
	#define PORT_SCK 		PC1		//74HC595 PIN 12
	#define PORT_RCK 		PC2		//74HC595 PIN 11
	#define PORT_OE 		PC3		//74HC595 PIN 13

	#define DDR_sr74hc595  DDRC
	#define DDR_SER 		DDC0	//74HC595 PIN 14
	#define DDR_SCK 		DDC1	//74HC595 PIN 12
	#define DDR_RCK 		DDC2	//74HC595 PIN 11	
	#define DDR_OE 			DDC3	//74HC595 PIN 13
#endif	//SR595_PORTC_HI
#endif	//SR595_PORTC

#if SR595_PORTD
	#define PORT_sr74hc595 PORTD	// EXT-Buchse (Pin 1-4) am AVR-NET-IO
	#define PORT_SER 		PD2		//74HC595 PIN 14
	#define PORT_SCK 		PD3		//74HC595 PIN 12
	#define PORT_RCK 		PD4		//74HC595 PIN 11
	#define PORT_OE 		PD5		//74HC595 PIN 13

	#define DDR_sr74hc595  DDRD
	#define DDR_SER 		DDD2	//74HC595 PIN 14
	#define DDR_SCK 		DDD3	//74HC595 PIN 12
	#define DDR_RCK 		DDD4	//74HC595 PIN 11	
	#define DDR_OE 			DDD5	//74HC595 PIN 13
#endif	//SR595_PORTD

#if SR595_WITH_OE
	#define WITH_OE		// use with /OE
#endif

//********** only for internal use. Don't change any value ***************

// Numbers of Bits over all 74HC595
#define sr74hc595_BYTES SR595_SIZE * 8

// global array 
extern unsigned char sr74hc595[];

// initialize the mikrocontroller
extern void sr74hc595_init(void);

// output to 74HC595
extern void sr74hc595_out(void);

// set a single Bit in arrays
extern void sr74hc595_setBit( unsigned char BitNumber );

// unset a single Bit in arrays
extern void sr74hc595_unsetBit( unsigned char BitNumber );

// set a port with a 8 Bit value
extern void sr74hc595_setPort( unsigned char Port, unsigned char Bits );

// unset a port
extern void sr74hc595_unsetPort( unsigned char Port );

// set all bit to logical High = 1
extern void sr74hc595_setall(void);

// set all bit to logical Low = 0
extern void sr74hc595_unsetall(void);

#endif /* _sr74hc595_H_ */
